<?php

// Copyright (c) 2005-2006 Regis COSNIER, All Rights Reserved.
// This program is free software and may be distributed
// according to the terms of the GNU General Public License (GPL) version 2 or later.

class Page
{
	var $pageId;
	var $menuId;
	var $memoId;
	var $menu;
	var $editable;
	var $showDateTime;
	var $showHours;
	var $mobitorPath;
	var $table;
	var $commentsTable;
	var $defaultCommentsSize;
	var $emailAddressOnNewComment;

	function Page()
	{
		$this->pageId = "";
		$this->menuId = "menu";
		$this->memoId = "memo";
		$this->menu = false;
		$this->editable = false;
		$this->showDateTime = true;
		$this->showHours = true;
		$this->mobitorPath = "/lib/mob/";
		$this->table = "mob_pages";
		$this->commentsTable = "mob_comments";
		$this->defaultCommentsSize = 10;
		$this->emailAddressOnNewComment = "";
	}

	function display()
	{
		if($this->menu)
		{
			$this->pageId = $this->menuId;
			$this->showDateTime = false;
			echo "					<div id='" . $this->pageId . "' class='menuBlock'>\n";
		}
		else
		{
			if($this->editable)
				echo "					<div id='" . $this->pageId . "' class='pageBlock' ondblclick='page" . $this->pageId . ".edit();'>\n";
			else
				echo "					<div id='" . $this->pageId . "' class='pageBlock'>\n";
		}
		
		if($this->pageId == "") { echo "You must specify a page"; return false; }
		
		$escapedTable = mysql_real_escape_string($this->table);
		$escapedPageId = mysql_real_escape_string($this->pageId);
		
		if($this->editable)
		{
			// If the table doesn't exist, we ask to create it.
			if(isset($_GET["CreatePageTable"]))
			{
				$sql = sprintf('CREATE TABLE `%s` ( `id` text NOT NULL, `title` text NOT NULL, `creation_date` datetime NOT NULL default \'0000-00-00 00:00:00\', `modify_date` datetime NOT NULL default \'0000-00-00 00:00:00\', `text` text, `has_comments` smallint(5) unsigned NOT NULL default \'0\', `text_undo` text NOT NULL, FULLTEXT KEY `id` (`id`) ) ENGINE=MyISAM DEFAULT CHARSET=utf8',
							$escapedTable);
			
				$result = mysql_query($sql);
				if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }

				//echo "The table $escapedTable has been successfully created. Click <a href=\"?page=$escapedPageId\">here</a> to create the main menu.";
				
				// Menu creation
				
				$title = "Menu";
				$menuText = "<a href=\"?page=" . $this->menuId . "\">$title</a><br />\n";
				
				// Insert a new element
				$sql = sprintf('INSERT INTO `%s` (`id`, `creation_date`, `modify_date`, `title`, `text`, `has_comments`) VALUES (\'%s\', NOW(), NOW(), \'%s\', \'%s\', \'%d\')',
						$escapedTable,
						$this->menuId,
						$title,
						$menuText,
						false);
				//echo "$sql<br />";
				$result = mysql_query($sql);
				if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }
				
				// Memo creation

				$title = "Memo";
				$memoText = "This is the memo";
				
				// Insert a new element
				$sql = sprintf('INSERT INTO `%s` (`id`, `creation_date`, `modify_date`, `title`, `text`, `has_comments`) VALUES (\'%s\', NOW(), NOW(), \'%s\', \'%s\', \'%d\')',
						$escapedTable,
						$this->memoId,
						$title,
						$memoText,
						false);
				//echo "$sql<br />";
				$result = mysql_query($sql);
				if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }

				echo "The table $escapedTable has been successfully created. Click <a href=\"?page=$this->menuId\">here</a> to view and edit the main menu.";
				
				return false;
			}
			if(mysql_num_rows(mysql_query("SHOW TABLES LIKE '" . $escapedTable . "'")) != 1)
			{
				print("Table " . $escapedTable . " doesn't exist. Click <a href='" . $_SERVER["SCRIPT_NAME"] . "?page=" . $escapedPageId . "&CreatePageTable=" . $escapedTable . "'>here</a> to create it.");
				return false;
			}
			
			// A post -> we change something
			if($_SERVER['REQUEST_METHOD'] == "POST" && $_REQUEST["PageId"] == $escapedPageId)
			{
				// Delete element
				if(isset($_REQUEST["DeleteYes"]))
				{
					$sql = sprintf('DELETE FROM `%s` WHERE `id` = \'%s\'',
							$escapedTable,
							$escapedPageId);
					//echo $sql . "<br>";
					$result = mysql_query($sql);
					if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }
				}
				else if(isset($_REQUEST["Undo"]))
				{
					$sql = sprintf('UPDATE `%s` SET `text` = `text_undo`, `modify_date` = NOW() WHERE `id` = \'%s\'',
							$escapedTable,
							$escapedPageId);
					//echo $sql . "<br>";
					$result = mysql_query($sql);
					if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }
				}
				else if(isset($_REQUEST["Save"]))
				{
					$title = ($_REQUEST["TitleEdit"]);
					$text = ($_REQUEST["TextEdit"]);
					$useComments =  (bool)($_REQUEST["UseComments"]);

					$sql = sprintf('UPDATE `%s` SET `text_undo` = `text`, `title` = \'%s\', `text` = \'%s\', `modify_date` = NOW(), `has_comments` = \'%d\' WHERE `id` = \'%s\'',
							$escapedTable,
							$title,
							$text,
							$useComments,
							$escapedPageId);
					//echo $sql . "<br>";
					$result = mysql_query($sql);
					if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }
				}
				else if(isset($_REQUEST["Create"]))
				{
					$title = ($_REQUEST["TitleEdit"]);
					if($title == "") $title = $escapedPageId;
					$text = ($_REQUEST["TextEdit"]);
					$useComments =  (bool)($_REQUEST["UseComments"]);

					// Insert a new element
					$sql = sprintf('INSERT INTO `%s` (`id`, `creation_date`, `modify_date`, `title`, `text`, `has_comments`) VALUES (\'%s\', NOW(), NOW(), \'%s\', \'%s\', \'%d\')',
							$escapedTable,
							$escapedPageId,
							$title,
							$text,
							$useComments);
					//echo "$sql<br />";
					$result = mysql_query($sql);
					if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }
					
					$menuText = "";
					$sql = sprintf('SELECT `text` FROM %s WHERE `id` = \'%s\'',
							$escapedTable,
							mysql_real_escape_string($this->menuId));

					//echo "$sql<br />";
					$record = mysql_query($sql);
					if($row = mysql_fetch_array($record))
					{
						$menuText = $row['text'];
					}
					mysql_free_result($record);
					$menuText .= "<a href=\"?page=" . $escapedPageId . "\">$title</a><br />\n";
					
					$sql = sprintf('UPDATE `%s` SET `text` = \'%s\', `modify_date` = NOW() WHERE `id` = \'%s\'',
							$escapedTable,
							mysql_real_escape_string($menuText),
							mysql_real_escape_string($this->menuId));
					//echo "$sql<br />";
					$result = mysql_query($sql);
					if(!$result) { echo "Could not mysql_query: " . mysql_error(); return false; }
					
					echo "The page $title ($escapedPageId) has been successfully created. Click <a href=\"?page=$escapedPageId\">here</a> to continue.";

					return false;
				}
			}
?>
						<script language="javascript">
					
							function Page(id)
							{
								this.id = id;

								this.form = document.getElementById("EditForm" + this.id);
								this.editor = document.getElementById("Editor" + this.id);
								this.title = document.getElementById("Title" + this.id);
								this.text = document.getElementById("Text" + this.id);
							
								this.buttonDelete = document.getElementById("Delete" + this.id);
								this.buttonDeleteNo = document.getElementById("DeleteNo" + this.id);
								this.buttonDeleteYes = document.getElementById("DeleteYes" + this.id);
								
								this.mobitorElement = document.getElementById("mobitor" + this.id);
								this.mob = mainMob;
							}
							Page.prototype.edit = function()
							{
								var sharePage = this;
								if(this.mob.beginNewEdition(function()
									{	// Callback called if this edition ended and another begin!
										if(confirm("Discard the current edition?"))
										{
											sharePage.editor.style.display = 'none';
											return true; // Keep the current edition
										} else return false; // Abort the attempt of new edition
									}))
								{
									this.mobitorElement.appendChild(this.mob.getEditorElement());
									this.editor.style.display = "inline";
									this.form.TitleEdit.value = this.title.innerHTML;

									var sharePage = this;
									this.mob.setDesignedModeReadyCallback(function() { sharePage.mob.setEditorContent(sharePage.text.innerHTML); });
									this.mob.enableDesignMode();
								}
							}
							Page.prototype.create = function()
							{
								var sharePage = this;
								if(this.mob.beginNewEdition(function()
									{	// Callback called if this edition ended and another begin!
										if(confirm("Discard the current edition?"))
										{
											sharePage.editor.style.display = 'none';
											return true; // Keep the current edition
										} else return false; // Abort the attempt of new edition
									}))
								{
									this.mobitorElement.appendChild(this.mob.getEditorElement());
									this.editor.style.display = "inline";
									this.form.TitleEdit.value = "";
									this.form.TextEdit.value = "";
								
									var sharePage = this;
									this.mob.setDesignedModeReadyCallback(function() { sharePage.mob.setEditorContent(""); });
									this.mob.enableDesignMode();
								}
							}
							Page.prototype.save = function()
							{
								this.form.TextEdit.value = this.mob.getEditorContent();
								this.form.submit();
							}
							Page.prototype.cancelEdit = function()
							{
								this.editor.style.display = 'none';
								this.mob.setBeginNewEditionCallback(null);
							}
							Page.prototype.remove = function()
							{
								this.buttonDeleteYes.style.display = 'inline';
								this.buttonDeleteNo.style.display = 'inline';
								this.buttonDelete.style.display = 'none';
							}
							Page.prototype.cancelDelete = function()
							{
								this.buttonDeleteYes.style.display = 'none';
								this.buttonDeleteNo.style.display = 'none';
								this.buttonDelete.style.display = 'inline';
							}
						</script>
						
						<form id="EditForm<?= $this->pageId ?>" method="POST">
							<input type="hidden" name="PageId" value="<?= $escapedPageId ?>" />
<?php
		
			$sql = sprintf('SELECT * FROM `%s` WHERE `id` = \'%s\'',
					$escapedTable,
					$escapedPageId);
			$record = mysql_query($sql);
		
			if($row = mysql_fetch_array($record))
			{
?>
							<div id="Editor<?= $this->pageId ?>" class="journalEditor" style="display:none">
								<input class="smallButton" type="submit" name="Save" value="Save" onclick="page<?= $this->pageId ?>.save();" />
								<input class="smallButton" type="button" id="Delete<?= $this->pageId ?>" value="Delete" onclick="page<?= $this->pageId ?>.remove();" />
								<input class="smallButton" type="button" id="DeleteNo<?= $this->pageId ?>" value="Cancel Delete" onclick="page<?= $this->pageId ?>.cancelDelete();" style="display:none" />
								<input class="smallButton" type="submit" id="DeleteYes<?= $this->pageId ?>" name="DeleteYes" value="Yes Delete" style="display:none; color:red" /><?php if(strlen($row['text_undo']) > 0) { ?>
								<input class="smallButton" type="submit" name="Undo" value="Undo" /><?php } ?>
								<input class="smallButton" type="checkbox" name="UseComments" <?php if($row['has_comments']) echo "checked"; ?> />
								<span class="smallButton"> Use comments</span>
								<input class="smallButton" type="button" value="Cancel" onclick="page<?= $this->pageId ?>.cancelEdit();" />
								<br />
								<b>Title</b> <input type="text" name="TitleEdit" /><br />
								<b>Text</b><br />
								<input type="hidden" name="TextEdit" />
								<div id="mobitor<?= $this->pageId ?>" style="border:1px solid #999; width:100%; height:500px;"></div><br />
							</div>
			
<?php
					$datetime = explode(" ", $row['creation_date']);
					if($this->showDateTime)
					{
						echo $datetime[0];
						if($this->showHours)
							echo " " . $datetime[1];
					}
?>
							<span class="journalTitle" id="Title<?= $this->pageId ?>"><?= $row['title'] ?></span>
							<br />
							<div class="journalText" id="Text<?= $this->pageId ?>"><?= $row['text'] ?></div>
					
							<script language="javascript">
								var page<?= $this->pageId ?>;
								//window.onload = function() { page<?= $this->pageId ?> = new Page("<?php echo $this->pageId; ?>", "<?= $this->pageId ?>"); };
								page<?= $this->pageId ?> = new Page("<?php echo $this->pageId; ?>", "<?= $this->pageId ?>");
							</script>
						</form>
<?php
				if($row['has_comments'])
				{
					echo "<br /><hr /><br />";

					include "comments.php";
					$childPage = new Comments;
					$childPage->table = $this->commentsTable;
					$childPage->commentsId = $escapedPageId;
					$childPage->showDateTime = true;
					$childPage->cssClass = "";
					$childPage->editable = $this->editable;
					$childPage->emailAddressOnNewComment = $this->emailAddressOnNewComment;
					$childPage->page_size = $this->defaultCommentsSize;
					$childPage->display();
				}
			}
			else
			{
?>
							<div id="Editor<?= $this->pageId ?>" class="journalEditor">
								<input class="smallButton" type="submit" name="Create" value="Create" onclick="page<?= $this->pageId ?>.save();"/>
								<input class="smallButton" type="checkbox" name="UseComments" <?php if($row['has_comments']) echo "checked"; ?> />
								<span class="smallButton"> Use comments</span>
								<br />
								<b>Title</b> <input type="text" name="TitleEdit" />
								<br />
								<b>Text</b>
								<br />
								<input type="hidden" name="TextEdit" />
								<div id="mobitor<?= $this->pageId ?>" style="border:1px solid #999; width:100%; height:500px;" />
								<br />
							</div>
							<script language="javascript">
								var page<?= $this->pageId ?>;
								page<?= $this->pageId ?> = new Page("<?php echo $this->pageId; ?>", "<?= $this->pageId ?>");
								page<?= $this->pageId ?>.create();
							</script>
						</form>
<?php
			}
			mysql_free_result($record);
		}
		else
		{
			if(mysql_num_rows(mysql_query("SHOW TABLES LIKE '" . $escapedTable . "'")) != 1)
			{
				print("Table " . $escapedTable . " doesn't exist. Click <a href='" . $_SERVER["SCRIPT_NAME"] . "?page=" . $escapedPageId . "&CreateTable=" . $escapedTable . "'>here</a> to create it.");
				return false;
			}

			$sql = sprintf('SELECT `creation_date`, `title`, `text`, `has_comments` FROM `%s` WHERE `id` = \'%s\'',
					$escapedTable,
					$escapedPageId);
			$record = mysql_query($sql);
			if($record)
			{
				if($row = mysql_fetch_array($record))
				{
					$datetime = explode(" ", $row['creation_date']);
					if($this->showDateTime)
					{
						echo $datetime[0];
						if($this->showHours)
							echo " " . $datetime[1];
					}
	?>
						<span class="journalTitle"><?= $row['title'] ?></span>
						<br />
						<div class="journalText">
<?php
print $row['text'] . "\n";
?>
						</div>
<?php
					if($row['has_comments'])
					{
						echo "<br /><hr /><br />";
	
						include "comments.php";
						$childPage = new Comments;
						$childPage->table = $this->commentsTable;
						$childPage->commentsId = $escapedPageId;
						$childPage->showDateTime = true;
						$childPage->cssClass = "";
						$childPage->editable = false;
						$childPage->emailAddressOnNewComment = $this->emailAddressOnNewComment;
						$childPage->page_size = $this->defaultCommentsSize;
						$childPage->display();
					}
				}
				mysql_free_result($record);
			}
		}
		
		//phpinfo();
?>					</div>
<?php
		return true;
	}
}
?>
